Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# OpenGLBufferC Class Reference

OpenGL graphics buffer class. More...

`#include <OpenGLBufferC.h>`

Inheritance diagram for OpenGLBufferC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
| Create new graphics device.
virtual PluginClass::ClassIdC | get_class_id () const
| Returns class ID.
virtual const char * | get_class_name ()
| Returns device's class name as NULL terminated string.
virtual DeviceInterfaceI * | query_interface (const PluginClass::SuperClassIdC &rSuperClassId)
| Extends device functionality, default implementation returns NULL.
virtual void | set_graphicsdevice (GraphicsDeviceI *pDevice)
| Sets the owner of the buffer.
virtual bool | init (PajaTypes::uint32 ui32Flags, PajaTypes::uint32 ui32Width=0, PajaTypes::uint32 ui32Height=0)
| Intialises a created graphics buffer.
virtual void | flush ()
| Flushes the rendering buffer.
virtual void | bind_texture (PajaSystem::DeviceInterfaceI *pInterface, PajaTypes::uint32 ui32Properties)
| Uses the graphics buffer as a texture in specified device.
virtual void | read_pixels (PajaTypes::uint32 ui32Flags, void *pData)
| Get contents of the graphics buffer.
virtual void | activate ()
## Static Public Member Functions
OpenGLBufferC * | create_new (GraphicsDeviceI *pDevice)
## Protected Member Functions
| OpenGLBufferC (GraphicsDeviceI *pDevice)
void | destroy ()
## Protected Attributes
OpenGLDeviceC * | m_pParentDev
OpenGLViewportC * | m_pViewport
HPBUFFERARB | m_hPBuffer
HDC | m_hPBufferDC
HGLRC | m_hPBufferRC
PajaTypes::uint32 | m_ui32InitFlags
PajaTypes::uint32 | m_ui32PBufferTexID

## Detailed Description

OpenGL graphics buffer class.

To get the dimensions of the graphics buffer, query the GraphicsViewport class from it.

## Member Function Documentation

virtual void bind_texture | ( | PajaSystem::DeviceInterfaceI * | pInterface,
|  | PajaTypes::uint32 | ui32Properties
| ) | `[virtual]`

| Uses the graphics buffer as a texture in specified device. Implements GraphicsBufferI.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Create new graphics device. Implements GraphicsBufferI.

virtual void flush | ( |  | ) | `[virtual]`

| Flushes the rendering buffer. Implements GraphicsBufferI.

virtual PluginClass::ClassIdC get_class_id | ( |  | ) | const`[virtual]`

| Returns class ID. Implements DeviceInterfaceI.

virtual const char* get_class_name | ( |  | ) | `[virtual]`

| Returns device's class name as NULL terminated string. Implements DeviceInterfaceI.

virtual bool init | ( | PajaTypes::uint32 | ui32Flags,
|  | PajaTypes::uint32 | ui32Width = 0,
|  | PajaTypes::uint32 | ui32Height = 0
| ) | `[virtual]`

| Intialises a created graphics buffer. If init() is called for already created buffer, the old contents is deleted and new buffer is initialised. Implements GraphicsBufferI.

virtual DeviceInterfaceI* query_interface | ( | const PluginClass::SuperClassIdC & | rSuperClassId | ) | `[virtual]`

| Extends device functionality, default implementation returns NULL. Reimplemented from DeviceInterfaceI.

virtual void read_pixels | ( | PajaTypes::uint32 | ui32Flags,
|  | void * | pData
| ) | `[virtual]`

| Get contents of the graphics buffer. Implements GraphicsBufferI.

virtual void set_graphicsdevice | ( | GraphicsDeviceI * | pDevice | ) | `[virtual]`

| Sets the owner of the buffer. Implements GraphicsBufferI.